;
; blink628.asm -- A PIC16F628 Hello World Program
;

;
; source code for gpasm by Byron Jeff - July 31st 2002
;

; The standard 1st Blinky LED program for PICDesigner.

; I/O 
; B0-B2,E0: Interface to 7445 decoder which grounds cathodes.
; D0-D7   : Interface to LED anodes.
      
;
; define PIC device type
;
	LIST	P=16F88

;
; define config fuses
;
   	__config _CONFIG1,_BODEN_OFF&_CP_OFF&_PWRTE_ON&_WDT_OFF&_LVP_ON&_INTRC_IO&_MCLR_OFF

; Reset the default radix to decimal. I use 0x for hex numbers
	RADIX	DEC
	
;
; include PIC register definitions, and some macros
;
#include "p16f88.inc"

; Define some variables

	CBLOCK	0x20
	c1	
	c2	
	c3	
	display
	endc

;
; code start
;
	org	0
	goto	init

	org	8		; Leave room for later interrupts

init
	banksel	OSCCON
	movlw	0x70
	movwf	OSCCON ^ 0x80
	movlw	0xf8
	movwf	TRISB ^ 0x80	;initialize port B so that portb0-b2 is out
	banksel	PORTB
	clrf	PORTB		; 
	clrf	PCLATH

	clrf	PORTB

	clrf	display		; clear the display

main
	movf	display,w	; get the display
	movwf	PORTB		; Set the column
	xorlw	7		; toggle bits
	movwf	display
	call	delay
	
	goto	main		; loop forever.

delay
	clrf	c1
	clrf	c2
	movlw	20
	movwf	c3

kwloop	decfsz	c1,F		; Delay awhile for char to xmit
	goto	kwloop
	decfsz	c2,F
	goto	kwloop
	decfsz	c3,F
	goto	kwloop
	return

	END
