        
	list p=16f88
	include "p16f88.inc"
	include "macros.inc"
	radix dec
	errorlevel -302
	errorlevel -306

        expand        
        ;noexpand



        ;; Full paths for include files on my system are:  
        ;;    /usr/share/gputils/header/
        ;;    /home/frank/pic/work/include/

;==========================================================================
;	__CONFIG 0x3F10

  __CONFIG 0x2007, _BODEN_OFF & _CP_OFF & _CPD_OFF & _PWRTE_ON & _WDT_OFF & _LVP_OFF & _MCLR_OFF & _INTRC_IO

        
;;; Pin assignments

;;;; Receive into PIC from the PC (while testing use RB0 on pin 6)
;;     later use RA5/Vpp/MCLR* on pin 4
        
        ;; for testing, I used RA7 on pin 15 
RXPORT    equ PORTA
RXPIN     equ 7
RXTRIS    equ TRISA

        ;; transmit serial data on RA6  (pin 16)
TXPORT    equ PORTA
TXPIN     equ 6
TXTRIS    equ TRISA

prtstr	macro	string
	movlw	HIGH(string)
	movwf	strh
	movlw	LOW(string)
	movwf	strl
	call	type
	endm

	cblock	0x40
	savechar
	c1
	c2
	c3
	strh
	strl
	memh
	meml
	endc
;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Start of program
;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        

	org	0x0004	; And we put in a fake interrupt handler also.
ISR
	;; This is the real interrupt vector.  It jumps to 0x0024 where
        ;;  the user must put his interrupt vector (or RTFIE)
        goto UserISR

        org 0x0008
        ;; we could start the bootloader code here since the user's code
        ;;  must skip the first 32-word block.  For now, we jump directly
        ;;  to Loader in high memory (see word address 0x0003 above).

;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        org 0x0020
UserISR
        ;; this is the beginning of the second 32-word block.  It is where the
        ;; user's code starts.  First, with 4 words allotted to the ISR
        ;; (the real ISR jumps here), then, at 0x0024, the user's startup code.
        ;; User is allowed 4 instructions here to jump to actual ISR
        retfie
        nop
        nop
        nop
        
Tx1	EQU	0xEBB
Rx1	EQU	0xEE3

;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        org 0x0024
	call	Initialize

	clrf	c1
	clrf	c2
	movlw	80
	movwf	c3

delay1	decfsz	c1,F
	goto	delay1

	decfsz	c2,F
	goto	delay1

	decfsz	c3,F
	goto	delay1

	prtstr	hello

UserApp        
        ;; probably, the bootloader's default user app will be to jump back to the
        ;; bootloader.
dumpmem	
	clrf	c1	; Use c1 as address counter.
	clrf	c2	; Use c2 as upper address counter.
dloop1	movlw	7	; cycle every 8 words.
	andwf	c1,W	
	btfss	STATUS,Z
	goto	dcont1

	prtstr	newline

	movf	c2,W
	call	printhex
	movf	c1,W
	call	printhex
	prtstr	colon
	
dcont1	
	call	readmem		; Read program memory from c2:c1 into memh:meml
	movf	memh,W
	call	printhex
	movf	meml,W
	call	printhex
	movlw	' '	
	call	emit

	incfsz	c1,F
	goto	dloop1	

	prtstr	cont1
	call	key
	incf	c2,F
	goto	dloop1
	
echoloop
	call	key
	movwf	savechar
	call	emit
	movf	savechar,W
	xorlw	13
	btfss	STATUS,Z
	goto	echoloop
	movlw	10
	call	emit
	goto	echoloop
	
readmem	
	bsf	STATUS,IRP	; Use FSR to access EE registers
	movlw	EEADR
	movwf	FSR
	movf	c1,w		; Get  low address
	movwf	INDF		; Put in EEADR
	movlw	EEADRH
	movwf	FSR
	movf	c2,W		; high address
	movwf	INDF		; Put in EEADR
	movlw	EECON1
	movwf	FSR
	bsf	INDF,EEPGD	; Set to program memory
	bsf	INDF,RD

	NOP			; Delay for the read
	NOP

	movlw	EEDATA		; Get low data
	movwf	FSR
	movf	INDF,W
	movwf	meml		; And store in meml	

	movlw	EEDATH		; Get low data
	movwf	FSR
	movf	INDF,W
	movwf	memh		; And store in meml	
	return

emit	pagesel	Tx1
	call	Tx1
	clrf	PCLATH
	return

key	pagesel	Rx1
	call	Rx1
	clrf	PCLATH
	return

type	; Print null terminated string whos address starts at strh:strl
	call	getnextchar
	clrf	PCLATH	
	xorlw	0
	btfsc	STATUS,Z
	return
	call	emit
	incfsz	strl,F
	goto	type	
	incf	strh,F
	goto	type

printhex
	movwf	strl
	swapf	strl,W
	andlw	0xf	; Get upper nybble.
	call	tohex
	call	emit
	movf	strl,W
	andlw	0xf	; Get upper nybble.
	call	tohex
	call	emit
	return

tohex	addwf	PCL,F
	dt	"0123456789ABCDEF"


hello	dt	"Welcome to the testing center. Dumping program memory\r\n"
newline dt	"\r\n",0
colon	dt	": ",0
cont1	dt	"\r\nPress ENTER to continue.\n\r",0

		

getnextchar
	movf	strh,W
	movwf	PCLATH
	movf	strl,W
	movwf	PCL

;;; Initialize
Initialize
        Bank0
        ;; Some of this might need to be customized for the specific
        ;;  application or class of application, particularly the
        ;;  direction of I/O pins so that, e.g. application circuit
        ;;  signals are in a safe state.

        ;; We use no interrupts, and its are disabled by default, but
        ;;  make it explicit by clearing INTCON here to disable all
        ;;  interrupts.
        clrf INTCON
        
        ;; We do not use the timer0 interrupt.  But, if we
        ;;  did, we would need to clear the T0IF flag prior to enabling
        ;;  the interrupt (and also do this before returning from its 
        ;;  int handler).
        ;bcf     INTCON, T0IF    ; turn off flag
        
        clrf PORTA
        clrf PORTB

        Bnk1
        ;; Set clock to 4 MHz
        movlw b'01100000'       ; 4 MHz
        movwf OSCCON
        
        ; turn analog/comparators off for 16LF819 and make pins digital
        movlw 0x06              ; make all PORTA pins digital
        movwf ADCON1            ;   (manual p. 82)
        
        ;; Port A direction
        clrf TRISA             ; all outputs (as much as possible)
        
        ;; Port B direction
        clrf TRISB             ; all outputs

        ;; for serial output, TXPORT,TXPIN (i.e. PORTA,1) must be output
        bcf TXTRIS, TXPIN       ; clear it to make RA1 an output

        ;; for serial input, RXPORT,RXPIN (i.e. at first PORTB,0 -- then later PORTA,5)
        ;;  must be an input
        bsf RXTRIS, RXPIN
        
        Bnk1
        ;; ** Option Register **
 	movlw B'11011101'  ; prescaler middle speed (divide by 32) and no pull-ups
	movwf OPTION_REG
        
	Bnk0

	clrf PIR1
	clrf INTCON
        
	;; Timer1, internal, divide by 8
	;; TMR1L then increments every 8 uS with a 4 MHz crystal
	;;  and can count up to (255 * 8) = 2040 uS ~= 2 mS
	;; Consult TMR1L for times under ~ 2 ms and
	;; consult TMR1H for times between about 2 mS and 1/2 second
	movlw B'00110001'
	movwf T1CON

	Bnk1
	clrf PIE1

	Bnk0
	clrf PIR1; do it again, just in case (clear interrupt flags)

	return
;;; end of 16LF819 bootloader initialize routine
        
 end
