;; -*- mode: asm; mode: outline-minor-mode; outline-regexp: ";;;+" -*-

;;; skeleton.asm
        
;;; PIC16LF819
        ;; fcs 22 July 2006

        ;; Here is a dummy program to illustrate the how to write an application
        ;; that can be used with the Pikme bootloader or with a hardware
        ;; programmer.

        ;; The bootloader ignores the first 32-word block of memory.

        ;; Put the application's interrupt code at 0x0020 (either put a jump
        ;; to your actual interrupt handler code there or put a retfie
        ;; instruction there.

        ;; Put the application's start code at 0x0024.

        ;; The interrupt vector is effectively 0x0020 (because the bootloader's
        ;; interrupt vector jumps to 0x0020) and the program must begin at
        ;; 0x0024.

        ;; So, ORG your interrupt code at 0x0020 and put interrupt code in
        ;; the first 4 instructions (e.g. rtfie, nop, nop, nop) and then start
        ;; the application at 0x0024.  (The 3 'nop's are not actually necessary
        ;; as long is the 'org 0x0024' statement is present.)

	list p=16f88
	include "p16f88.inc"

        ;; uncomment and possibly edit following line if you include
        ;; any macros, etc.
	;include "macros.inc"
        
	radix dec

        expand        
        ;noexpand
        
;==========================================================================
;	__CONFIG 0x3F10

  __CONFIG 0x2007, _BODEN_OFF & _CP_OFF & _CPD_OFF & _PWRTE_ON & _WDT_OFF & _LVP_OFF & _MCLR_OFF & _INTRC_IO

        ;; Above configuration word will be ignored when using the bootloader but
        ;; will be programmed into the PIC when you use a hardware programmer.

        
;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; First 32-word block.
;;;     This is ignored by the bootloader but is not ignored when
;;;     using a hardware programmer.
;;;     By putting this code here, the very same hex file can be used either
;;;     with the bootloader or with a hardware programmer.
;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	org	0x0000
        goto UserApp

	org	0x0004
ISR
        goto UserISR


        
;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Second 32-word block.
;;;     This is where the application's interrupt and application code
;;;     go.
;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        org 0x0020
        ;; Your interrupt handler *must* be org'd at 0x0020.
        ;; Use a return from interrupt instruction (retfie) or put
        ;; a jump to your actual interrupt handler (goto xxxx).
UserISR
        retfie
        nop
        nop
        nop
        
        org 0x0024
        ;; Your application *must* be org'd at 0x0024, because that is
        ;; the address where the bootloader jumps.
UserApp

        ;; put your application code here

;
; blink628.asm -- A PIC16F628 Hello World Program
;

;
; source code for gpasm by Byron Jeff - July 31st 2002
;

; The standard 1st Blinky LED program for PICDesigner.

; I/O 
; B0-B2,E0: Interface to 7445 decoder which grounds cathodes.
; D0-D7   : Interface to LED anodes.
      
;
; define PIC device type
;
;	LIST	P=16F88

;
; define config fuses
;
;   	__config _CONFIG1,_BODEN_OFF&_CP_OFF&_PWRTE_ON&_WDT_OFF&_LVP_ON&_INTRC_IO&_MCLR_OFF

; Reset the default radix to decimal. I use 0x for hex numbers
	RADIX	DEC
	
;
; include PIC register definitions, and some macros
;
#include "p16f88.inc"

; Define some variables

	CBLOCK	0x20
	c1	
	c2	
	c3	
	display
	endc

;
; code start
;
;	org	0
;	goto	init

;	org	8		; Leave room for later interrupts

init
	banksel	OSCCON
	movlw	0x70
	movwf	OSCCON ^ 0x80
	movlw	0xf8
	movwf	TRISB ^ 0x80	;initialize port B so that portb0-b2 is out
	banksel	PORTB
	clrf	PORTB		; 
	clrf	PCLATH

	clrf	PORTB

	clrf	display		; clear the display

main
	movf	display,w	; get the display
	movwf	PORTB		; Set the column
	xorlw	7		; toggle bits
	movwf	display
	call	delay
	
	goto	main		; loop forever.

delay
	clrf	c1
	clrf	c2
	movlw	20
	movwf	c3

kwloop	decfsz	c1,F		; Delay awhile for char to xmit
	goto	kwloop
	decfsz	c2,F
	goto	kwloop
	decfsz	c3,F
	goto	kwloop
	return

 end
